# 
# reader pro soubory FASTQ
# ~ yielduje postupně všechny záznamy z FASTQ-souboru
# 
def FastqReader(file):
    with open(file) as f:
        # pomocný prázdný seznam do začátku
        record = []
        for i,line in enumerate(f):
            # Jsme na poslední (čtvrté) řádce záznamu?
            if i % 4 == 0:
                # vynecháme výpis prvního pomocného prázdného seznamu
                if record != []:
                    yield record
                # v příštím kroku začneme načítat nový/další záznam
                record = []
            # načtenou řádku přidáme do záznamu
            line = line.strip()
            record.append(line)
        # tisk posledního záznamu
        yield record

# 
# reader pro soubory FASTA
# ~ yielduje postupně všechny záznamy z FASTA-souboru
# 
def FastaReader(file):
    with open(file) as f:
        header, seq = '', ''
        for line in f:
            line = line.strip()
            if line.startswith('>'):
                if seq != '':
                    yield header, seq
                    seq = ''
                header = line
            else:
                seq += line
        # vrácení posledního záznamu
        yield header, seq
